//+------------------------------------------------------------------+
//|                                                         Kris.mq4 |
//+------------------------------------------------------------------+
//|                                              Indicator Trend.mq4 |
//|                                                      K.Piligrimm |
//|                                             piligrimm_fx@mail.ru |
//+------------------------------------------------------------------+
#property copyright "K.Piligrimm"
#property link      "K.Piligrimm"
#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

//---- input parameters
extern int Threshold= 125;
static datetime time0=0;          
extern int LengthSample=1300;    //      .

string NameGlobalVariableGV_0="GV_0";
string NameGlobalVariableGV_1="GV_1";
string NameGlobalVariableGV_2="GV_2";
string NameGlobalVariableGV_3="GV_3";  
double Mt,MS[2],PIP[2];
int m,j,i,nn,nt=0,iq,jm,gm,handle,dm;                
int mc0=0,k0=0,Bars1;  
double GV[],GM1[],JS0[][2],Ex0,Ex1,Ex2,Ex3,GV_0,GV_1,GV_2,GV_3; 
//---- buffers
double ExtMapBuffer1[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   
    SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,3);
    SetIndexDrawBegin(0,LengthSample);
    SetIndexBuffer(0,ExtMapBuffer1);
 
   PIP[1]=Threshold*Point; PIP[0]=NormalizeDouble(PIP[1]/7,Digits);  
     Bars1=LengthSample+100;
   int element_count1=ArrayResize(GM1, LengthSample+101);
   int element_count2=ArrayResize(JS0, LengthSample+100);
    Ex0=0;Ex1=0;Ex2=0;Ex3=0;
    GlobalVariableSet(NameGlobalVariableGV_0, Ex0);
    GlobalVariableSet(NameGlobalVariableGV_1, Ex1);
    GlobalVariableSet(NameGlobalVariableGV_2, Ex2);
    GlobalVariableSet(NameGlobalVariableGV_3, Ex3);        
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
    GlobalVariableDel(NameGlobalVariableGV_0); 
    GlobalVariableDel(NameGlobalVariableGV_1);
    GlobalVariableDel(NameGlobalVariableGV_2); 
    GlobalVariableDel(NameGlobalVariableGV_3); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
    {//0
     
    if(time0 == Time[0]) return(0);  ////////////////////////////////
        time0 = Time[0];              //////////////////////////////// 
         
      JS0[0][0]=Close[Bars1];JS0[0][1]=0;     
    for (i=0; i<Bars1; i++)  
     {//5
       m=Bars1-i;
       Mt=MathAbs(Close[Bars1]-Close[m]);
    if (Mt>PIP[0])
     {//4
       JS0[1][0]=Close[m];JS0[1][1]=i;nt=i;
       i=Bars1;
     }//4  
     }//5  
       k0=1; 
       m=Bars1-1;
     for( nn=nt; nn<Bars1; nn++)
      {//6     
    if ((Low[m-nn]-JS0[k0][0])<-PIP[1])  
      {//7
       k0++;   
       JS0[k0][0]=Low[m-nn];JS0[k0][1]=nn;
      }//7
    else if ((High[m-nn]-JS0[k0][0])>PIP[1]) 
      {//8
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//8
    if ((JS0[k0-1][0]>JS0[k0][0])&&((Low[m-nn]-JS0[k0][0])<0))
       
      if ((Low[m-nn]-JS0[k0-1][0])<-PIP[0])  
      {//9
       k0++;
       JS0[k0][0]=Low[m-nn];JS0[k0][1]=nn;
      }//9
    else   
      {//10
       JS0[k0][0]=Low[m-nn];JS0[k0][1]=nn; 
      }//10 
    else if ((JS0[k0-1][0]<JS0[k0][0])&&((High[m-nn]-JS0[k0][0])>0))
       
      if ((High[m-nn]-JS0[k0-1][0])>PIP[0]) 
      {//11
       k0++;
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//11
    else  
      {//12
       JS0[k0][0]=High[m-nn];JS0[k0][1]=nn; 
      }//12   
      }//6
      
      gm=0;
      GM1[gm]=JS0[0][0];    
    for( iq=1; iq<=k0; iq++)
     {//13    
      m=JS0[iq][1]-JS0[iq-1][1];
     if (m==0)
      m=1;
      Mt=(JS0[iq][0]-JS0[iq-1][0])/m;
    for( jm=0; jm<m; jm++) 
     {//14
      gm++;
      GM1[gm]=GM1[gm-1]+Mt;    
     }//14 
     }//13 
      nn=Bars1-JS0[k0][1]-1;
      int element_count3=ArrayResize(GV, LengthSample-nn);
      m=gm-LengthSample;
    for (i=0; i<LengthSample-nn; i++)
        GV[i]=GM1[i+m+nn+1];
          
    for(j=0; j<LengthSample-nn; j++)   
      ExtMapBuffer1[LengthSample-j-1]=GV[j];
    dm=LengthSample-nn; 
 
      Ex0=JS0[k0][0];Ex1=JS0[k0-1][0];Ex2=JS0[k0-2][0];Ex3=JS0[k0-3][0];
      GlobalVariableSet(NameGlobalVariableGV_0, Ex0);
      GlobalVariableSet(NameGlobalVariableGV_1, Ex1);
      GlobalVariableSet(NameGlobalVariableGV_2, Ex2);
      GlobalVariableSet(NameGlobalVariableGV_3, Ex3); 
      GV_0=GlobalVariableGet(NameGlobalVariableGV_0);
      GV_1=GlobalVariableGet(NameGlobalVariableGV_1);
      GV_2=GlobalVariableGet(NameGlobalVariableGV_2);
      GV_3=GlobalVariableGet(NameGlobalVariableGV_3);
   
      mc0++;
 Comment("Indicator Trend - creator K.Piligrimm <piligrimm_fx@mail.ru>", "\n","LengthSample"," ","= ",LengthSample,"  ","Threshold"," ","= ",Threshold,"  ","AmountRunning"," ","= ",mc0);
   
//----K
   return(0);

  

     }//1
//+------------------------------------------------------------------+